Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2918)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2920)
@@ -15,4 +15,7 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
+! Copyright 2015-2018 Czech Technical University in Prague
+! Copyright 2015-2018 Institute of Computer Science of the 
+!                     Czech Academy of Sciences, Prague
 ! Copyright 1997-2018 Leibniz Universitaet Hannover
 !------------------------------------------------------------------------------!
@@ -25,4 +28,22 @@
 ! -----------------
 ! $Id$
+! - Bugfix: Initialize pcbl array (=-1)
+! moh.hefny:
+! - Use precalculated apparent solar positions for direct irradiance
+! - Cumulative commit for radiation changes - merged RTM version 2.0:
+! - New version of radiation interaction
+! - Added new 2D raytracing process using whole vertical column at once (e.g.
+!   memory efficiency & much less RMA)
+! - Removed virtual surfaces
+! - Separate processing of direct and diffuse solar radiation, new discreti
+!   zation by azimuth and elevation angles
+! - Diffuse radiation processed cumulatively using sky view factor
+! - Enabled limiting of number of view factors between real surfaces, thus
+!   greatly enhancing scalability
+! - Minor bugfixes and enhancements
+! - Fixing bugs from moving radiation interaction from urban_surface_mod
+! 
+! 
+! 2906 2018-03-19 08:56:40Z Giersch
 ! NAMELIST paramter read/write_svf_on_init have been removed, functions 
 ! check_open and close_file are used now for opening/closing files related to
@@ -97,5 +118,5 @@
 ! 
 ! 2544 2017-10-13 18:09:32Z maronga
-! Moved date and time quantitis to separate module date_and_time_mod 
+! Moved date and time quantitis to separate module date_and_time_mod
 ! 
 ! 2512 2017-10-04 08:26:59Z raasch
@@ -262,5 +283,6 @@
                latitude, longitude, large_scale_forcing, lsf_surf,             &
                message_string, microphysics_morrison, plant_canopy, pt_surface,&
-               rho_surface, surface_pressure, time_since_reference_point
+               rho_surface, surface_pressure, time_since_reference_point,      &
+               urban_surface, land_surface, end_time, spinup_time, dt_spinup
 
     USE cpulog,                                                                &
@@ -272,5 +294,5 @@
     USE date_and_time_mod,                                                     &
         ONLY:  calc_date_and_time, d_hours_day, d_seconds_hour, day_of_year,   &
-               time_utc
+               d_seconds_year, day_of_year_init, time_utc_init, time_utc
 
     USE indices,                                                               &
@@ -294,5 +316,5 @@
 
     USE plant_canopy_model_mod,                                                &
-        ONLY:  pc_heating_rate, lad_s, usm_lad_rma
+        ONLY:  pc_heating_rate, lad_s
 
     USE pegrid
@@ -380,6 +402,5 @@
                 sun_direction = .FALSE.,              & !< flag parameter indicating whether solar direction shall be calculated
                 average_radiation = .FALSE.,          & !< flag to set the calculation of radiation averaging for the domain
-                atm_surfaces = .FALSE.,               & !< flag parameter indicating wheather surfaces of atmospheric cells will be considered in calculating SVF
-                radiation_interactions = .TRUE.,      & !< flag to control if radiation interactions via sky-view factors shall be considered
+                radiation_interactions = .FALSE.,     & !< flag to control if radiation interactions via sky-view factors shall be considered
                 surf_reflections = .TRUE.               !< flag to switch the calculation of radiation interaction between surfaces.
                                                         !< When it switched off, only the effect of buildings and trees shadow will
@@ -581,7 +602,7 @@
     INTEGER(iwp), PARAMETER                        ::  ix = 4                             !< position of i-index in surfl and surf
 
-    INTEGER(iwp), PARAMETER                        ::  nsurf_type = 21                    !< number of surf types incl. phys.(land+urban) & (atm.,sky,boundary) surfaces - 1
-
-    INTEGER(iwp), PARAMETER                        ::  iup_u    = 0                       !< 0 - index of urban ubward surface (ground or roof)
+    INTEGER(iwp), PARAMETER                        ::  nsurf_type = 16                    !< number of surf types incl. phys.(land+urban) & (atm.,sky,boundary) surfaces - 1
+
+    INTEGER(iwp), PARAMETER                        ::  iup_u    = 0                       !< 0 - index of urban upward surface (ground or roof)
     INTEGER(iwp), PARAMETER                        ::  idown_u  = 1                       !< 1 - index of urban downward surface (overhanging)
     INTEGER(iwp), PARAMETER                        ::  inorth_u = 2                       !< 2 - index of urban northward facing wall
@@ -590,5 +611,5 @@
     INTEGER(iwp), PARAMETER                        ::  iwest_u  = 5                       !< 5 - index of urban westward facing wall
 
-    INTEGER(iwp), PARAMETER                        ::  iup_l    = 6                       !< 6 - index of land ubward surface (ground or roof)
+    INTEGER(iwp), PARAMETER                        ::  iup_l    = 6                       !< 6 - index of land upward surface (ground or roof)
     INTEGER(iwp), PARAMETER                        ::  inorth_l = 7                       !< 7 - index of land northward facing wall
     INTEGER(iwp), PARAMETER                        ::  isouth_l = 8                       !< 8 - index of land southward facing wall
@@ -603,26 +624,17 @@
     INTEGER(iwp), PARAMETER                        ::  iwest_a  = 16                      !< 16- index of atm. cell westward facing virtual surface
 
-    INTEGER(iwp), PARAMETER                        ::  isky     = 17                      !< 17 - index of top border of the urban surface layer ("urban sky")
-    INTEGER(iwp), PARAMETER                        ::  inorth_b = 18                      !< 18 - index of free north border of the domain (south facing)
-    INTEGER(iwp), PARAMETER                        ::  isouth_b = 19                      !< 19 - index of north south border of the domain (north facing)
-    INTEGER(iwp), PARAMETER                        ::  ieast_b  = 20                      !< 20 - index of east border of the domain (west facing)
-    INTEGER(iwp), PARAMETER                        ::  iwest_b  = 21                      !< 21 - index of wast border of the domain (east facing)
-
-    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  idir = (/0, 0,0, 0,1,-1,0,0, 0,1,-1,0, 0,0, 0,1,-1, 0, 0,0,-1,1/)   !< surface normal direction x indices
-    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  jdir = (/0, 0,1,-1,0, 0,0,1,-1,0, 0,0, 0,1,-1,0, 0, 0,-1,1, 0,0/)   !< surface normal direction y indices
-    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  kdir = (/1,-1,0, 0,0, 0,1,0, 0,0, 0,1,-1,0, 0,0, 0,-1, 0,0, 0,0/)   !< surface normal direction z indices
+    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  idir = (/0, 0,0, 0,1,-1,0,0, 0,1,-1,0, 0,0, 0,1,-1/)   !< surface normal direction x indices
+    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  jdir = (/0, 0,1,-1,0, 0,0,1,-1,0, 0,0, 0,1,-1,0, 0/)   !< surface normal direction y indices
+    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  kdir = (/1,-1,0, 0,0, 0,1,0, 0,0, 0,1,-1,0, 0,0, 0/)   !< surface normal direction z indices
                                                                                           !< parameter but set in the code
 
 
 !-- indices and sizes of urban and land surface models
-    INTEGER(iwp)                                   ::  nskys            !< number of sky surfaces in local processor
-    INTEGER(iwp)                                   ::  startland        !< start index of block of land and roof surfaces!-- block variables needed for calculation of the plant canopy model inside the urban surface model
-    INTEGER(iwp)                                   ::  endland          !< end index of block of land and roof surfaces    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  pct              !< top layer of the plant canopy
-    INTEGER(iwp)                                   ::  nlands           !< number of land and roof surfaces in local processor    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  pch              !< heights of the plant canopy
-    INTEGER(iwp)                                   ::  startwall        !< start index of block of wall surfaces    INTEGER(iwp)                                   ::  npcbl            !< number of the plant canopy gridboxes in local processor
-    INTEGER(iwp)                                   ::  endwall          !< end index of block of wall surfaces    INTEGER(wp), DIMENSION(:,:), ALLOCATABLE       ::  pcbl             !< k,j,i coordinates of l-th local plant canopy box pcbl[:,l] = [k, j,
-    INTEGER(iwp)                                   ::  nwalls           !< number of wall surfaces in local processor    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinsw          !< array of absorbed sw radiation for local plant canopy box
-    INTEGER(iwp)                                   ::  nborder          !< number of border surfaces in local processor    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinlw          !< array of absorbed lw radiation for local plant canopy box
-
+    INTEGER(iwp)                                   ::  startland        !< start index of block of land and roof surfaces
+    INTEGER(iwp)                                   ::  endland          !< end index of block of land and roof surfaces
+    INTEGER(iwp)                                   ::  nlands           !< number of land and roof surfaces in local processor
+    INTEGER(iwp)                                   ::  startwall        !< start index of block of wall surfaces
+    INTEGER(iwp)                                   ::  endwall          !< end index of block of wall surfaces
+    INTEGER(iwp)                                   ::  nwalls           !< number of wall surfaces in local processor
 
 !-- indices and sizes of urban and land surface models
@@ -631,12 +643,5 @@
     INTEGER(iwp)                                   ::  nsurfl           !< number of all surfaces in local processor
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  nsurfs           !< array of number of all surfaces in individual processors
-    INTEGER(iwp)                                   ::  startsky         !< start index of block of sky
-    INTEGER(iwp)                                   ::  endsky           !< end index of block of sky
-    INTEGER(iwp)                                   ::  startenergy      !< start index of block of real surfaces (land, walls and roofs)
-    INTEGER(iwp)                                   ::  endenergy        !< end index of block of real surfaces (land, walls and roofs)
-    INTEGER(iwp)                                   ::  nenergy          !< number of real surfaces in local processor
     INTEGER(iwp)                                   ::  nsurf            !< global number of surfaces in index array of surfaces (nsurf = proc nsurfs)
-    INTEGER(iwp)                                   ::  startborder      !< start index of block of border
-    INTEGER(iwp)                                   ::  endborder        !< end index of block of border
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  surfstart        !< starts of blocks of surfaces for individual processors in array surf
                                                                         !< respective block for particular processor is surfstart[iproc]+1 : surfstart[iproc+1]
@@ -648,4 +653,6 @@
     INTEGER(wp), DIMENSION(:,:), ALLOCATABLE       ::  pcbl             !< k,j,i coordinates of l-th local plant canopy box pcbl[:,l] = [k, j, i]
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinsw          !< array of absorbed sw radiation for local plant canopy box
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinswdir       !< array of absorbed direct sw radiation for local plant canopy box
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinswdif       !< array of absorbed diffusion sw radiation for local plant canopy box
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinlw          !< array of absorbed lw radiation for local plant canopy box
 
@@ -653,6 +660,5 @@
     LOGICAL                                        ::  split_diffusion_radiation = .TRUE. !< split direct and diffusion dw radiation
                                                                                           !< (.F. in case the radiation model already does it)    
-    LOGICAL                                        ::  energy_balance_surf_h = .TRUE.     !< flag parameter indicating wheather the energy balance is calculated for horizontal surfaces
-    LOGICAL                                        ::  energy_balance_surf_v = .TRUE.     !< flag parameter indicating wheather the energy balance is calculated for vertical surfaces
+    LOGICAL                                        ::  rma_lad_raytrace = .FALSE.         !< use MPI RMA to access LAD for raytracing (instead of global array)
     LOGICAL                                        ::  mrt_factors = .FALSE.              !< whether to generate MRT factor files during init
     INTEGER(iwp)                                   ::  nrefsteps = 0                      !< number of reflection steps to perform
@@ -660,6 +666,12 @@
     INTEGER(iwp), PARAMETER                        ::  svf_code_len = 15                  !< length of code for verification of the end of svf file
     CHARACTER(svf_code_len), PARAMETER             ::  svf_code = '*** end svf ***'       !< code for verification of the end of svf file
-    INTEGER(iwp), PARAMETER                        ::  usm_version_len = 10               !< length of identification string of usm version
-    CHARACTER(usm_version_len), PARAMETER          ::  usm_version = 'USM v. 1.0'         !< identification of version of binary svf and restart files
+    INTEGER(iwp), PARAMETER                        ::  rad_version_len = 10               !< length of identification string of rad version
+    CHARACTER(rad_version_len), PARAMETER          ::  rad_version = 'RAD v. 1.0'         !< identification of version of binary svf and restart files
+    INTEGER(iwp)                                   ::  raytrace_discrete_elevs = 40       !< number of discretization steps for elevation (nadir to zenith)
+    INTEGER(iwp)                                   ::  raytrace_discrete_azims = 80       !< number of discretization steps for azimuth (out of 360 degrees)
+    REAL(wp)                                       ::  max_raytracing_dist = -999.0_wp    !< maximum distance for raytracing (in metres)
+    REAL(wp)                                       ::  min_irrf_value = 1e-6_wp           !< minimum potential irradiance factor value for raytracing
+    REAL(wp), DIMENSION(1:30)                      ::  svfnorm_report_thresh = 1e21_wp    !< thresholds of SVF normalization values to report
+    INTEGER(iwp)                                   ::  svfnorm_report_num                 !< number of SVF normalization thresholds to report
 
 !-- radiation related arrays to be used in radiation_interaction routine
@@ -697,6 +709,15 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfins          !< array of sw radiation falling to local surface after i-th reflection
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinl          !< array of lw radiation for local surface after i-th reflection
-    
-                                                                        !< Inward radiation is also valid for virtual surfaces (radiation leaving domain)
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  skyvf            !< array of sky view factor for each local surface
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  skyvft           !< array of sky view factor including transparency for each local surface
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  dsitrans         !< dsidir[isvfl,i] = path transmittance of i-th
+                                                                        !< direction of direct solar irradiance per target surface
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  dsitransc        !< dtto per plant canopy box
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  dsidir           !< dsidir[:,i] = unit vector of i-th
+                                                                        !< direction of direct solar irradiance
+    INTEGER(iwp)                                   ::  ndsidir          !< number of apparent solar directions used
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  dsidir_rev       !< dsidir_rev[ielev,iazim] = i for dsidir or -1 if not present
+
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinsw         !< array of sw radiation falling to local surface including radiation from reflections
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinlw         !< array of lw radiation falling to local surface including radiation from reflections
@@ -713,12 +734,13 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfoutlw        !< array of total lw radiation outgoing from nonvirtual surfaces surfaces after all reflection
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfhf           !< array of total radiation flux incoming to minus outgoing from local surface
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  rad_net_l        !< local copy of rad_net (net radiation at surface)
 
 !-- block variables needed for calculation of the plant canopy model inside the urban surface model
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  csfsurf          !< csfsurf[:,icsf] = index of target surface and csf grid index for csf[icsf]
     REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  csf              !< array of plant canopy sink fators + direct irradiation factors (transparency)
-    REAL(wp), DIMENSION(:,:,:), POINTER            ::  usm_lad          !< subset of lad_s within urban surface, transformed to plain Z coordinate
-    REAL(wp), DIMENSION(:), POINTER                ::  usm_lad_g        !< usm_lad globalized (used to avoid MPI RMA calls in raytracing)
+    REAL(wp), DIMENSION(:,:,:), POINTER            ::  sub_lad          !< subset of lad_s within urban surface, transformed to plain Z coordinate
+    REAL(wp), DIMENSION(:), POINTER                ::  sub_lad_g        !< sub_lad globalized (used to avoid MPI RMA calls in raytracing)
+    REAL(wp)                                       ::  prototype_lad    !< prototype leaf area density for computing effective optical depth
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  nzterr, plantt   !< temporary global arrays for raytracing
+    INTEGER(iwp)                                   ::  plantt_max
 
 !-- arrays and variables for calculation of svf and csf
@@ -736,5 +758,5 @@
     INTEGER(iwp)                                   ::  ncsfl            !< no. of csf in local processor
                                                                         !< needed only during calc_svf but must be here because it is
-                                                                        !< shared between subroutines usm_calc_svf and usm_raytrace
+                                                                        !< shared between subroutines calc_svf and raytrace
     INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE    ::  gridpcbl         !< index of local pcb[k,j,i]
 
@@ -748,5 +770,10 @@
                   DIMENSION(:), ALLOCATABLE        ::  lad_disp         !< array of displaycements of lad in local array of proc lad_ip
 #endif
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  lad_s_ray        !< array of received lad_s for appropriate gridboxes crossed by ray 
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  lad_s_ray        !< array of received lad_s for appropriate gridboxes crossed by ray
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  rt2_track
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  rt2_track_lad
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  rt2_track_dist
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  rt2_dist
+
 
 
@@ -839,4 +866,8 @@
        MODULE PROCEDURE radiation_interaction_init
     END INTERFACE radiation_interaction_init
+ 
+    INTERFACE radiation_presimulate_solar_pos
+       MODULE PROCEDURE radiation_presimulate_solar_pos
+    END INTERFACE radiation_presimulate_solar_pos
 
     INTERFACE radiation_radflux_gridbox
@@ -872,5 +903,5 @@
            radiation_radflux_gridbox, radiation_calc_svf, radiation_write_svf, &
            radiation_interaction, radiation_interaction_init,                  &
-           radiation_read_svf
+           radiation_read_svf, radiation_presimulate_solar_pos
             
 
@@ -888,19 +919,17 @@
            zenith, calc_zenith, sun_direction, sun_dir_lat, sun_dir_lon,       &
            split_diffusion_radiation,                                          &
-           energy_balance_surf_h, energy_balance_surf_v,                       &
            nrefsteps, mrt_factors, dist_max_svf, nsvfl, svf,                   &
            svfsurf, surfinsw, surfinlw, surfins, surfinl, surfinswdir,         &
            surfinswdif, surfoutsw, surfoutlw, surfinlwdif, rad_sw_in_dir,      &
            rad_sw_in_diff, rad_lw_in_diff, surfouts, surfoutl, surfoutsl,      &
-           surfoutll, idir, jdir, kdir, id, iz, iy, ix, isky, nenergy, nsurfs, &
-           surfstart, surf, surfl, nsurfl, pcbinsw, pcbinlw, pcbl, npcbl,      &
-           startenergy, endenergy, iup_u, inorth_u, isouth_u, ieast_u, iwest_u,&
-           iup_l, inorth_l, isouth_l, ieast_l, iwest_l, startsky, endsky,      &
-           startborder, endborder, nsurf_type, nzub, nzut, inorth_b,idown_a,   &
-           isouth_b, ieast_b, iwest_b, nzu, pch, nsurf, iup_a, inorth_a,       &
-           isouth_a, ieast_a, iwest_a, idsvf, ndsvf, idcsf, ndcsf, kdcsf, pct, &
-           radiation_interactions, startwall, startland, endland, endwall
-
-
+           surfoutll, idir, jdir, kdir, id, iz, iy, ix, nsurfs, surfstart,     &
+           surf, surfl, nsurfl, pcbinswdir, pcbinswdif, pcbinsw, pcbinlw,      &
+           pcbl, npcbl, iup_u, inorth_u, isouth_u, ieast_u, iwest_u,           &
+           iup_l, inorth_l, isouth_l, ieast_l, iwest_l,                        &
+           nsurf_type, nzub, nzut, nzu, pch, nsurf,                            &
+           iup_a, idown_a, inorth_a, isouth_a, ieast_a, iwest_a,               &
+           idsvf, ndsvf, idcsf, ndcsf, kdcsf, pct,                             &
+           radiation_interactions, startwall, startland, endland, endwall,     &
+           skyvf, skyvft
 
 #if defined ( __rrtmg )
@@ -1246,9 +1275,21 @@
 !
 !--    Radiation interactions
-       IF ( urban_surface .AND.  .NOT. radiation_interactions )  THEN
-          message_string = 'radiation_interactions = .T. is required '//       &
-                           'when using the urban surface model'
+       IF ( nrefsteps < 1  .AND.  radiation_interactions )  THEN
+          message_string = 'nrefsteps must be > 0 when using LSM/USM to' //    &
+                           'account for surface outgoing SW flux.'       //    &
+                           'You may set surf_reflections = .FALSE. to '  //    &
+                           'diable surface reflections instead.'
           CALL message( 'check_parameters', 'PA0999', 1, 2, 0, 6, 0 )
        ENDIF
+
+!
+!--    Incialize svf normalization reporting histogram
+       svfnorm_report_num = 1
+       DO WHILE ( svfnorm_report_thresh(svfnorm_report_num) < 1e20_wp          &
+                   .AND. svfnorm_report_num <= 30 )
+          svfnorm_report_num = svfnorm_report_num + 1
+       ENDDO
+       svfnorm_report_num = svfnorm_report_num - 1
+
 
  
@@ -1498,4 +1539,22 @@
        IF ( radiation_scheme == 'clear-sky'  .OR.                              &
             radiation_scheme == 'constant')  THEN
+
+
+!
+!--       Allocate arrays for incoming/outgoing short/longwave radiation
+          IF ( .NOT. ALLOCATED ( rad_sw_in ) )  THEN
+             ALLOCATE ( rad_sw_in(0:0,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+          IF ( .NOT. ALLOCATED ( rad_sw_out ) )  THEN
+             ALLOCATE ( rad_sw_out(0:0,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_lw_in ) )  THEN
+             ALLOCATE ( rad_lw_in(0:0,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+          IF ( .NOT. ALLOCATED ( rad_lw_out ) )  THEN
+             ALLOCATE ( rad_lw_out(0:0,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+
 !
 !--       Allocate average arrays for incoming/outgoing short/longwave radiation
@@ -1515,26 +1574,31 @@
 !
 !--       Allocate arrays for broadband albedo, and level 1 initialization
-!--       via namelist paramter. 
-          IF ( .NOT. ALLOCATED(surf_def_h(0)%albedo) )                         &
+!--       via namelist paramter, unless already allocated.
+          IF ( .NOT. ALLOCATED(surf_def_h(0)%albedo) )  THEN
              ALLOCATE( surf_def_h(0)%albedo(0:0,1:surf_def_h(0)%ns) )
-          IF ( .NOT. ALLOCATED(surf_lsm_h%albedo) )                            &
+             surf_def_h(0)%albedo = albedo
+          ENDIF
+          IF ( .NOT. ALLOCATED(surf_lsm_h%albedo) )  THEN
              ALLOCATE( surf_lsm_h%albedo(0:2,1:surf_lsm_h%ns)     )
-          IF ( .NOT. ALLOCATED(surf_usm_h%albedo) )                            &
+             surf_lsm_h%albedo    = albedo
+          ENDIF
+          IF ( .NOT. ALLOCATED(surf_usm_h%albedo) )  THEN
              ALLOCATE( surf_usm_h%albedo(0:2,1:surf_usm_h%ns)     )
-
-          surf_def_h(0)%albedo = albedo
-          surf_lsm_h%albedo    = albedo
-          surf_usm_h%albedo    = albedo
+             surf_usm_h%albedo    = albedo
+          ENDIF
+
           DO  l = 0, 3
-             IF ( .NOT. ALLOCATED( surf_def_v(l)%albedo ) )                    &
+             IF ( .NOT. ALLOCATED( surf_def_v(l)%albedo ) )  THEN
                 ALLOCATE( surf_def_v(l)%albedo(0:0,1:surf_def_v(l)%ns) )
-             IF ( .NOT. ALLOCATED( surf_lsm_v(l)%albedo ) )                    &
+                surf_def_v(l)%albedo = albedo
+             ENDIF
+             IF ( .NOT. ALLOCATED( surf_lsm_v(l)%albedo ) )  THEN
                 ALLOCATE( surf_lsm_v(l)%albedo(0:2,1:surf_lsm_v(l)%ns) )
-             IF ( .NOT. ALLOCATED( surf_usm_v(l)%albedo ) )                    &
+                surf_lsm_v(l)%albedo = albedo
+             ENDIF
+             IF ( .NOT. ALLOCATED( surf_usm_v(l)%albedo ) )  THEN
                 ALLOCATE( surf_usm_v(l)%albedo(0:2,1:surf_usm_v(l)%ns) )
-
-             surf_def_v(l)%albedo = albedo
-             surf_lsm_v(l)%albedo = albedo
-             surf_usm_v(l)%albedo = albedo
+                surf_usm_v(l)%albedo = albedo
+             ENDIF
           ENDDO
 !
@@ -2523,4 +2587,15 @@
              ENDIF
 
+!
+!--          Fill out values in radiation arrays
+             DO  m = 1, surf%ns
+                i = surf%i(m)
+                j = surf%j(m)
+                rad_sw_in(0,j,i) = surf%rad_sw_in(m)
+                rad_sw_out(0,j,i) = surf%rad_sw_out(m)
+                rad_lw_in(0,j,i) = surf%rad_lw_in(m)
+                rad_lw_out(0,j,i) = surf%rad_lw_out(m)
+             ENDDO
+
           END SUBROUTINE radiation_clearsky_surf
 
@@ -2711,4 +2786,15 @@
 
              ENDIF
+
+!
+!--          Fill out values in radiation arrays
+             DO  m = 1, surf%ns
+                i = surf%i(m)
+                j = surf%j(m)
+                rad_sw_in(0,j,i) = surf%rad_sw_in(m)
+                rad_sw_out(0,j,i) = surf%rad_sw_out(m)
+                rad_lw_in(0,j,i) = surf%rad_lw_in(m)
+                rad_lw_out(0,j,i) = surf%rad_lw_out(m)
+             ENDDO
 
           END SUBROUTINE radiation_constant_surf
@@ -2802,12 +2888,9 @@
                                   sw_radiation, unscheduled_radiation_calls,   &
                                   split_diffusion_radiation,                   &
-                                  energy_balance_surf_h,                       &
-                                  energy_balance_surf_v,                       &
-                                  nrefsteps,                                   &
-                                  mrt_factors,                                 &
+                                  max_raytracing_dist, min_irrf_value,         &
+                                  nrefsteps, mrt_factors, rma_lad_raytrace,    &
                                   dist_max_svf,                                &
                                   average_radiation,                           &
-                                  radiation_interactions, atm_surfaces,        &
-                                  surf_reflections
+                                  surf_reflections, svfnorm_report_thresh
        
        line = ' '
@@ -2829,4 +2912,7 @@
 !--    Set flag that indicates that the radiation model is switched on
        radiation = .TRUE.
+
+!--    Set radiation_interactions flag according to urban_ and land_surface flag
+       IF ( urban_surface  .OR.  land_surface ) radiation_interactions = .TRUE.
 
  10    CONTINUE
